// MODELER.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MODELER.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MODELERDoc.h"
#include "MODELERView.h"

#include "DCOMserver.h"

#include "MapGenLocation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMODELERApp

BEGIN_MESSAGE_MAP(CMODELERApp, CWinApp)
	//{{AFX_MSG_MAP(CMODELERApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(LINK_BUGREPORT, OnBugreport)
	ON_COMMAND(LINK_FAQ, OnFaq)
	ON_COMMAND(LINK_FEEDBACK, OnFeedback)
	ON_COMMAND(LINK_HOME_PAGE, OnHomePage)
	ON_COMMAND(ID_OPTIONS_MAPGENLOCATION, OnOptionsMapgenlocation)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMODELERApp construction

CMODELERApp::CMODELERApp() :
	MainFrame(NULL)
{
	m_bLocalMachine = TRUE;
	strcpy(m_szServerName, "");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMODELERApp object

CMODELERApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMODELERApp initialization

BOOL CMODELERApp::InitInstance()
{
	// solo una istanza del modeller per macchina
	if (!FirstInstance()) 
        return FALSE;

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("VitoPlantamura.COM"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	SetRegistryBase (_T("Settings"));

	// Initialize all Managers for usage. They are automatically constructed
	// if not yet present
	InitContextMenuManager();
	InitKeyboardManager();

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_MODELETYPE,
		RUNTIME_CLASS(CMODELERDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMODELERView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// *** legge nel registro ***

	if ( GetProfileInt("Modeler Settings","DCOM (Local Machine)",m_bLocalMachine ? 1 : 0) )
		m_bLocalMachine=TRUE;
	else
		m_bLocalMachine=FALSE;

	CString ServerName = GetProfileString("Modeler Settings","DCOM (Server Name)",m_szServerName);
	strcpy(m_szServerName,(char*)(LPCTSTR)ServerName);

	// **************************

	LoadCustomState ();

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	// *** crea il thread per DCOM ***

	m_hEvent_0 = CreateEvent(NULL, FALSE, FALSE, NULL);
	m_hEvent_1 = CreateEvent(NULL, FALSE, FALSE, NULL);

	if ( m_hEvent_0==NULL || m_hEvent_1==NULL ) {

		AfxMessageBox("CreateEvent failed! Unable to initialize server!");

	}
	else {

		char		dcom_message[1024]="";

		m_ThreadH=::CreateThread(NULL,
			0,
			DCOM_thread,
			(LPVOID)dcom_message,
			0,
			&m_ThreadID);

		WaitForSingleObject(m_hEvent_0, INFINITE);

		if ( strlen(dcom_message) != 0 )
			AfxMessageBox(dcom_message);

	}

	return TRUE;
}

int CMODELERApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class

	if ( m_hEvent_1 )
		SetEvent(m_hEvent_1);

	if ( m_hEvent_0 )
		CloseHandle(m_hEvent_0);

	if ( m_hEvent_1 )
		CloseHandle(m_hEvent_1);

	// *** scrive nel registro ***

	WriteProfileInt("Modeler Settings","DCOM (Local Machine)",m_bLocalMachine ? 1 : 0);

	WriteProfileString("Modeler Settings","DCOM (Server Name)",m_szServerName);

	// ***************************
	
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMODELERApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


void CMODELERApp::PreLoadState ()
{

	GetContextMenuManager()->AddMenu (_T("My menu"), IDR_CONTEXT_MENU);

	// TODO: add another context menus here
}


/////////////////////////////////////////////////////////////////////////////
// CMODELERApp message handlers

DWORD WINAPI CMODELERApp::DCOM_thread (LPVOID parameter)
{
	char		*message=(char*)parameter;

	RegisterDCOMServer(message);

	SetEvent(theApp.m_hEvent_0);

	WaitForSingleObject(theApp.m_hEvent_1, INFINITE);

	UnRegisterDCOMServer();

	return 0;
}

const char* MyMainWndClassName = "MAPGENMODELER";

BOOL CMODELERApp::FirstInstance()
{
    CWnd *PrevCWnd, *ChildCWnd;
    // Determine if another window with our class name exists.
    PrevCWnd = CWnd::FindWindow(MyMainWndClassName, NULL);
    if (PrevCWnd != NULL)
    {
        // If so, does it have any pop-ups?
        ChildCWnd=PrevCWnd->GetLastActivePopup();
        // Bring the main window to the top.
        PrevCWnd->SetForegroundWindow();
        // If iconic, restore the main window.
        if (PrevCWnd->IsIconic())
            PrevCWnd->ShowWindow(SW_RESTORE);
        // If there are pop-ups, bring them along too!
        if (PrevCWnd != ChildCWnd)
            ChildCWnd->SetForegroundWindow();
        // Return FALSE. This isn't the first instance
        // and we are done activating the previous one.
        return FALSE;
    }
    else
        // First instance. Proceed as normal.
        return TRUE;
}

LPCSTR RegisterSimilarClass(LPCSTR lpszNewClassName, LPCSTR lpszOldClassName, UINT nIDResource)
{
       // Get class info for old class.
       //
       HINSTANCE hInst = AfxGetInstanceHandle();
       WNDCLASS wc;
       if (!::GetClassInfo(hInst, lpszOldClassName, &wc)) {
              TRACE("Can't find window class %s\n", lpszOldClassName);
              return NULL;
       }

       // Register new class with same info, but different name.
       //
       wc.lpszClassName = lpszNewClassName;
	   wc.hIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(nIDResource));
       if (!AfxRegisterClass(&wc)) {
              TRACE("Unable to register window class%s\n", lpszNewClassName);
              return NULL;
       }
       return lpszNewClassName;
}

void CMODELERApp::OnBugreport() 
{
	// TODO: Add your command handler code here
	::ShellExecute (NULL, NULL, "http://www.3dheavyindustries.com", NULL, NULL, NULL);
}

void CMODELERApp::OnFaq() 
{
	// TODO: Add your command handler code here
	::ShellExecute (NULL, NULL, "http://www.3dheavyindustries.com", NULL, NULL, NULL);
}

void CMODELERApp::OnFeedback() 
{
	// TODO: Add your command handler code here
	::ShellExecute (NULL, NULL, "http://www.3dheavyindustries.com", NULL, NULL, NULL);
}

void CMODELERApp::OnHomePage() 
{
	// TODO: Add your command handler code here
	::ShellExecute (NULL, NULL, "http://www.vitoplantamura.com", NULL, NULL, NULL);
}

void CMODELERApp::OnOptionsMapgenlocation() 
{
	CMapGenLocation		wndDialog;

	wndDialog.DoModal();
}

void *CMODELERApp::LoadFileFromResources (char *name, char *type, int *lenght)
{
	HINSTANCE		resources_handle = AfxGetResourceHandle();

	void			*ptr;
	HGLOBAL			handle;
	HRSRC			hResInfo;
	void			*pointer;
	int				size;

	hResInfo=FindResource(resources_handle,name,type);
	if ( hResInfo==NULL )
		return(NULL);

	handle=LoadResource(resources_handle,hResInfo);
	if ( handle==NULL )
		return(NULL);

	pointer=LockResource(handle);
	if ( pointer==NULL )
		return(NULL);

	size=SizeofResource(resources_handle,hResInfo);
	if ( size==0 )
		return(NULL);
	if ( lenght )
		*lenght=size;

	ptr=malloc(size);
	if ( ptr==NULL )
		return(NULL);

	memcpy(ptr,pointer,size);

	// ritorna
	return(ptr);
}