// MODELERView.h : interface of the CMODELERView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MODELERVIEW_H__99F2A340_2717_4E03_BEFD_C8352DD0000F__INCLUDED_)
#define AFX_MODELERVIEW_H__99F2A340_2717_4E03_BEFD_C8352DD0000F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AnimOpenGLRenderer.h"
#include "TimeSlider.h"

class CMODELERView : public CView
{
protected: // create from serialization only
	CMODELERView();
	DECLARE_DYNCREATE(CMODELERView)

// Attributes
public:
	CMODELERDoc* GetDocument();

	int			m_iShownAnimation; // inizializzato a -1

	BOOL		m_bIsPlaying;

	BOOL		m_bStopButtonEnabled;

	UINT		m_nTimerElapse;

	void SetShownAnimationNumber (int iShownAnimation = -1);

// Operations
public:

	void StopAnimation () { if ( m_bIsPlaying ) OnPlaypause(); }
	void PlayPauseAnimation () { OnPlaypause(); }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMODELERView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation Helpers
protected:

	BOOL HasTimeRange (CSceneRoot *pSceneRoot)
	{
		return pSceneRoot->m_pGI->first_frame == pSceneRoot->m_pGI->last_frame ? FALSE : TRUE;
	}

	UINT CalculateTimerElapse (CSceneRoot *pSceneRoot)
	{
		UINT		nTimerElapse = 1000 / pSceneRoot->m_pGI->frame_speed;

		nTimerElapse -= nTimerElapse / 3; // aumenta arbitrariamente la velocit

		if ( nTimerElapse == 0 )
		{
			nTimerElapse = 1;
		}

		return nTimerElapse;
	}

	CBCGToolbarButton *GetToolbarButtonPtr (UINT uiCmd);

// Implementation
public:
	virtual ~CMODELERView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	CAnimOpenGLRenderer		m_wndRenderer;
	CTimeSlider				m_wndTimeSlider;

// Generated message map functions
protected:
	//{{AFX_MSG(CMODELERView)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	afx_msg void OnContextMenu(CWnd*, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnGotoStart();
	afx_msg void OnUpdateGotoStart(CCmdUI* pCmdUI);
	afx_msg void OnPreviousFrame();
	afx_msg void OnUpdatePreviousFrame(CCmdUI* pCmdUI);
	afx_msg void OnPlaypause();
	afx_msg void OnUpdatePlaypause(CCmdUI* pCmdUI);
	afx_msg void OnStop();
	afx_msg void OnUpdateStop(CCmdUI* pCmdUI);
	afx_msg void OnNextFrame();
	afx_msg void OnUpdateNextFrame(CCmdUI* pCmdUI);
	afx_msg void OnGotoEnd();
	afx_msg void OnUpdateGotoEnd(CCmdUI* pCmdUI);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MODELERView.cpp
inline CMODELERDoc* CMODELERView::GetDocument()
   { return (CMODELERDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MODELERVIEW_H__99F2A340_2717_4E03_BEFD_C8352DD0000F__INCLUDED_)
