// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MODELER.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MODELERDoc.h"
#include "MODELERView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)


BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_INCOMINGANIMATIONS, OnViewIncominganimations)
	ON_UPDATE_COMMAND_UI(ID_VIEW_INCOMINGANIMATIONS, OnUpdateViewIncominganimations)
	ON_COMMAND(ID_VIEW_ANIMATIONCONTROL, OnViewAnimationcontrol)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ANIMATIONCONTROL, OnUpdateViewAnimationcontrol)
	ON_COMMAND(ID_VIEW_ANIMINFO, OnViewAniminfo)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ANIMINFO, OnUpdateViewAniminfo)
	ON_WM_ACTIVATEAPP()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_VIEW_CUSTOMIZE, OnViewCustomize)
	ON_REGISTERED_MESSAGE(BCGM_RESETTOOLBAR, OnToolbarReset)
	ON_REGISTERED_MESSAGE(BCGM_TOOLBARMENU, OnToolbarContextMenu)
	ON_REGISTERED_MESSAGE(BCGM_CUSTOMIZEHELP, OnHelpCustomizeToolbars)
	ON_WM_GETMINMAXINFO()
	ON_COMMAND(ID_WINDOW_NEW, OnWindowNew)
	ON_MESSAGE(WPM_SCB_CLOSE_BUTTON_PRESSED, OnWpmScbCloseButtonPressed)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	ASSERT (theApp.MainFrame == NULL);
	theApp.MainFrame=this;
}

CMainFrame::~CMainFrame()
{
	ASSERT (theApp.MainFrame == this);
	theApp.MainFrame=NULL;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	CBCGToolBar::EnableQuickCustomization ();


	// TODO: Define your own basic commands. Be sure, that each pulldown 
	// menu have at least one basic command.

	CList<UINT, UINT>	lstBasicCoomads;

	lstBasicCoomads.AddTail (ID_VIEW_TOOLBARS);
	lstBasicCoomads.AddTail (ID_FILE_NEW);
	lstBasicCoomads.AddTail (ID_FILE_OPEN);
	lstBasicCoomads.AddTail (ID_FILE_SAVE);
	lstBasicCoomads.AddTail (ID_APP_EXIT);
	lstBasicCoomads.AddTail (ID_EDIT_CUT);
	lstBasicCoomads.AddTail (ID_EDIT_PASTE);
	lstBasicCoomads.AddTail (ID_EDIT_UNDO);
	lstBasicCoomads.AddTail (ID_APP_ABOUT);
	lstBasicCoomads.AddTail (ID_VIEW_TOOLBAR);
	lstBasicCoomads.AddTail (ID_VIEW_CUSTOMIZE);
	lstBasicCoomads.AddTail (ID_WINDOW_TILE_HORZ);

	CBCGToolBar::SetBasicCommands (lstBasicCoomads);
	CBCGToolBar::AddToolBarForImageCollection (IDR_MENUIMAGES);

	if (!m_wndMenuBar.Create (this))
	{
		TRACE0("Failed to create menubar\n");
		return -1;      // fail to create
	}

	m_wndMenuBar.SetBarStyle(m_wndMenuBar.GetBarStyle() | CBRS_SIZE_DYNAMIC);

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndAnimationControl.Create(this, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC, ID_VIEW_ANIMATIONCONTROL) ||
		!m_wndAnimationControl.LoadToolBar(IDR_ANIMATIONCONTROL))
	{
		TRACE0("Failed to create Animation Control toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	if (!m_wndIncomingAnimationsBar.Create (_T("Incoming Animations"), this, CSize (200, 200),
		TRUE /* Has gripper */, ID_VIEW_INCOMINGANIMATIONS,
		WS_CHILD | WS_VISIBLE | CBRS_LEFT))
	{
		TRACE0("Failed to create incoming animations bar\n");
		return -1;      // fail to create
	}

	if (!m_wndAnimInfoBar.Create (_T("Animation Information"), this, CSize (200, 200),
		TRUE /* Has gripper */, ID_VIEW_ANIMINFO,
		WS_CHILD | WS_VISIBLE | CBRS_LEFT))
	{
		TRACE0("Failed to create animation information bar\n");
		return -1;      // fail to create
	}

	CString strMainToolbarTitle;
	strMainToolbarTitle.LoadString (IDS_MAIN_TOOLBAR);
	m_wndToolBar.SetWindowText (strMainToolbarTitle);

	CString strAniControlToolbarTitle;
	strAniControlToolbarTitle.LoadString (IDS_ANIMATIONCONTROL_TOOLBAR);
	m_wndAnimationControl.SetWindowText (strAniControlToolbarTitle);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndMenuBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndAnimationControl.EnableDocking(CBRS_ALIGN_ANY);
	m_wndIncomingAnimationsBar.EnableDocking(CBRS_ALIGN_LEFT | CBRS_ALIGN_RIGHT);
	m_wndAnimInfoBar.EnableDocking(CBRS_ALIGN_LEFT | CBRS_ALIGN_RIGHT);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndMenuBar);
	DockControlBar(&m_wndToolBar);
	DockControlBarLeftOf(&m_wndAnimationControl, &m_wndToolBar);
	DockControlBar(&m_wndIncomingAnimationsBar,AFX_IDW_DOCKBAR_RIGHT);
	DockControlBar(&m_wndAnimInfoBar, AFX_IDW_DOCKBAR_LEFT);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.lpszClass = RegisterSimilarClass(MyMainWndClassName, cs.lpszClass, IDR_MAINFRAME);

	if ( cs.lpszClass == NULL )
	{
		return FALSE;
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnViewCustomize()
{
	//------------------------------------
	// Create a customize toolbars dialog:
	//------------------------------------
	CBCGToolbarCustomize* pDlgCust = new CBCGToolbarCustomize (this,
		TRUE /* Automatic menus scaning */);

	pDlgCust->Create ();
}

LRESULT CMainFrame::OnToolbarContextMenu(WPARAM,LPARAM lp)
{
	CPoint point (LOWORD (lp), HIWORD(lp));

	CMenu menu;
	VERIFY(menu.LoadMenu (IDR_POPUP_TOOLBAR));

	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);

	CBCGPopupMenu* pPopupMenu = new CBCGPopupMenu;
	pPopupMenu->Create (this, point.x, point.y, pPopup->Detach ());

	return 0;
}

afx_msg LRESULT CMainFrame::OnToolbarReset(WPARAM /*wp*/,LPARAM)
{
	// TODO: reset toolbar with id = (UINT) wp to its initial state:
	//
	// UINT uiToolBarId = (UINT) wp;
	// if (uiToolBarId == IDR_MAINFRAME)
	// {
	//		do something with m_wndToolBar
	// }

	return 0;
}

LRESULT CMainFrame::OnHelpCustomizeToolbars(WPARAM wp, LPARAM lp)
{
	int iPageNum = (int) wp;

	CBCGToolbarCustomize* pDlg = (CBCGToolbarCustomize*) lp;
	ASSERT_VALID (pDlg);

	// TODO: show help about page number iPageNum


	return 0;
}

BOOL CMainFrame::OnShowPopupMenu (CBCGPopupMenu* pMenuPopup)
{
	//---------------------------------------------------------
	// Replace ID_VIEW_TOOLBARS menu item to the toolbars list:
	//---------------------------------------------------------
    CMDIFrameWnd::OnShowPopupMenu (pMenuPopup);

    if (pMenuPopup != NULL &&
		pMenuPopup->GetMenuBar ()->CommandToIndex (ID_VIEW_TOOLBARS) >= 0)
    {
		if (CBCGToolBar::IsCustomizeMode ())
		{
			//----------------------------------------------------
			// Don't show toolbars list in the cuztomization mode!
			//----------------------------------------------------
			return FALSE;
		}

		pMenuPopup->RemoveAllItems ();

		CMenu menu;
		VERIFY(menu.LoadMenu (IDR_POPUP_TOOLBAR));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);

		pMenuPopup->GetMenuBar ()->ImportFromMenu (*pPopup, TRUE);
    }

	return TRUE;
}


void CMainFrame::OnViewIncominganimations() 
{
	// TODO: Add your command handler code here
	ShowControlBar (&m_wndIncomingAnimationsBar,
					!(m_wndIncomingAnimationsBar.GetStyle () & WS_VISIBLE),
					FALSE);
	RecalcLayout ();
}

void CMainFrame::OnUpdateViewIncominganimations(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (m_wndIncomingAnimationsBar.GetStyle () & WS_VISIBLE);
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI)
{
	lpMMI->ptMinTrackSize.x = 380;
	lpMMI->ptMinTrackSize.y = 300;

	CMDIFrameWnd::OnGetMinMaxInfo(lpMMI);
}

void CMainFrame::OnViewAnimationcontrol() 
{
	// TODO: Add your command handler code here
	ShowControlBar (&m_wndAnimationControl,
					!(m_wndAnimationControl.GetStyle () & WS_VISIBLE),
					FALSE);
	RecalcLayout ();
}

void CMainFrame::OnUpdateViewAnimationcontrol(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (m_wndAnimationControl.GetStyle () & WS_VISIBLE);
}

void CMainFrame::OnWindowNew()
{
	// *** legge la configurazione di quella corrente ***

	BOOL			bMaximized;

	CChildFrame		*pChildFrame = (CChildFrame*)MDIGetActive(&bMaximized);
	ASSERT( pChildFrame != NULL );

	CMODELERView	*pView = (CMODELERView*)pChildFrame->GetActiveView();
	ASSERT( pView != NULL );

	int				iShownAnimation = pView->m_iShownAnimation;

	// *** crea la nuova view ***

	CMDIFrameWnd::OnWindowNew();

	// *** configura la nuova view ***

	pChildFrame = (CChildFrame*)MDIGetActive(&bMaximized);
	ASSERT( pChildFrame != NULL );

	pView = (CMODELERView*)pChildFrame->GetActiveView();
	ASSERT( pView != NULL );

	pView->SetShownAnimationNumber(iShownAnimation);
}

void CMainFrame::OnViewAniminfo() 
{
	ShowControlBar (&m_wndAnimInfoBar,
					!(m_wndAnimInfoBar.GetStyle () & WS_VISIBLE),
					FALSE);

	m_wndAnimInfoBar.OnUpdateCmdUI(this, FALSE);

	RecalcLayout ();
}

void CMainFrame::OnUpdateViewAniminfo(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_wndAnimInfoBar.GetStyle () & WS_VISIBLE);
}

LRESULT CMainFrame::OnWpmScbCloseButtonPressed (WPARAM wpScbPointer, LPARAM)
{
	CBCGSizingControlBar	*pwndScb = (CBCGSizingControlBar*)wpScbPointer;

	if ( pwndScb == &m_wndAnimInfoBar )
	{
		m_wndAnimInfoBar.OnUpdateCmdUI(this, FALSE);
	}

	return 0;
}

void CMainFrame::OnActivateApp(BOOL bActive, HTASK hTask) 
{
	CMDIFrameWnd::OnActivateApp(bActive, hTask);

	if ( bActive && ( GetStyle() & WS_VISIBLE ) )
	{
		CWnd		*pwndChild = GetLastActivePopup();

		SetForegroundWindow();

		if ( this != pwndChild )
		{
			pwndChild->SetForegroundWindow();
		}
	}
}
